#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main( void )
{
	FILE *fin, *fout;
	int brojRedova = 0, brojStupaca = 0, red, stup, duljinaZmije;
	char **A, c;
	
	if( ( fin = fopen( "ulaz.3D.in", "rt" ) ) == NULL )
	{
		printf( "Greska kod otvaranja datoteke ulaz.in\n" );
		exit( 0 );
	}
	
	while( fscanf( fin, "%c", &c ) == 1 )
	{
		if( brojRedova == 0 && c != '\n' ) ++brojStupaca;
		if( c == '\n' ) ++brojRedova;
	}
	
	A = (char **) malloc( brojRedova * sizeof( char * ) );
	for( red = 0; red < brojRedova; ++red )
	    A[red] = (char *) malloc( ( brojStupaca + 1 ) * sizeof( char ) );

	rewind( fin );
	for( red = 0; red < brojRedova; ++red )
	    fscanf( fin, "%s", A[red] );

	red = stup = 0; duljinaZmije = 1;
	while( 1 )
	{
		if( red + 1 < brojRedova && A[red + 1][stup] == 'X' )
		    ++red, ++duljinaZmije;
		else if( stup + 1 < brojStupaca && A[red][stup + 1] == 'X' )
		    ++stup, ++duljinaZmije;
		else
		    break;
	}
	
	if( ( fout = fopen( "izlaz.in", "wt" ) ) == NULL )
	{
		printf( "Greska kod otvaranja datoteke ulaz.in\n" );
		exit( 0 );
	}
	
	fprintf( fout, "%d\n", duljinaZmije );
	fclose( fin ); fclose( fout );

	for( red = 0; red < brojRedova; ++red )
	    free( A[red] );
	free( A );

	return 0;
}
